;----------------------------------------------
;       _digit
;       input       eax = value
;       ; var       _digit_n    = cx ; digit
;       ; var       _digit_div  = bx ; div
;       output      ds:[dx] = output string
;----------------------------------------------
                PUBLIC  _digit
_digit          PROC    NEAR
                push    es
                push    si
                push    bx
                push    ds
                pop     es
                push    eax
                cmp     cx,0FFFFh
                je      Noalign
                xor     dx,dx
                mov     ax,128
                div     _digit_div
                cmp     cx,ax
                jbe     cx_ok1
                mov     cx,ax
cx_ok1:         
                cmp     cx,1
                jae     cx_ok2
                mov     cx,ax
cx_ok2:         nop
Noalign:        nop
                std
                 mov     di,offset ds:_convert$end
                 xor     ebx,ebx
                 mov     bx,ds:_digit_div
                 mov    al,0
                 stosb   
                pop     eax  ;   ax=value
                xor     edx,edx
_digit_ent:     
                div     ebx
                mov     si,offset ds:_hextbl
                add     si,dx
                movsb
                dec     cx
                xor     edx,edx
                or      eax,eax
                jnz     _digit_ent
_digit_end:     
                cmp     cx,33
                jae     digit_err
                or      cx,cx
                jz      digit_err
                mov     al,_digit_zsup
digit_spc_loop: stosb
               loop     digit_spc_loop
digit_err:      mov     al,COLOR_ATTRIB
                stosb
                cld
                inc     di
                mov     dx,di
                pop     bx
                pop     si
                pop     es
                ret
_digit_div      DW      10
_digit_zsup     DB      ' '
_hextbl         DB      "0123456789ABCDEF"
KetaBuf         DB      "                                 "
_convert$end    DB      0
_digit          ENDP
;----------------------------------------------
;       digitx
;----------------------------------------------
digitx          PROC    near
                pusha
                mov     COLOR_ATTRIB,0A1h
                xchg    cx,ax
                xor     eax,eax
                xchg    ax,cx
                mov     cx,4
                mov     _digit_zsup,'0'
                mov     _digit_div,16
                call    _digit
                call    _puts
                popa
                ret
digitx          ENDP

;----------------------------------------------
;       digitb
;----------------------------------------------
digitb          PROC    near
                pusha
                mov     COLOR_ATTRIB,0C1h
                xchg    cx,ax
                xor     eax,eax
                xchg    ax,cx
                mov     cx,32
                mov     _digit_zsup,'0'
                mov     _digit_div,2
                call    _digit
                call    _puts
                popa
                ret
digitb          ENDP

;----------------------------------------------
;       digitx2
;----------------------------------------------
digitx2         PROC    near
                mov     COLOR_ATTRIB,0A1h
                pusha
                xchg    cx,ax
                xor     eax,eax
                xchg    ax,cx
                mov     ah,0
                mov     cx,2
                mov     _digit_zsup,'0'
                mov     _digit_div,16
                call    _digit
                call    _puts
                popa
                ret
digitx2         ENDP
;----------------------------------------------
;       digitx3
;----------------------------------------------
digitx3         PROC    near
                mov     COLOR_ATTRIB,0E1h
                pusha
                xchg    cx,ax
                xor     eax,eax
                xchg    ax,cx
                mov     ah,0
                mov     cx,3
                mov     _digit_zsup,'0'
                mov     _digit_div,16
                call    _digit
                mov     bx,dx
                mov     al,' '
                mov     [bx+1],al
                call    _puts
                popa
                ret
digitx3         ENDP
;----------------------------------------------
;       digitlx
;----------------------------------------------
digitlx          PROC    near
                 pusha
                 mov     COLOR_ATTRIB,061h
                 mov     cx,8
                 mov     _digit_zsup,'0'
                 mov     _digit_div,16
                 call    _digit
                 call    _puts
                 popa
                 ret
digitlx          ENDP

;----------------------------------------------
;       digitw
;----------------------------------------------
digitw          PROC    near
                mov     COLOR_ATTRIB,081h
                pusha
                mov     _digit_zsup,' '
                mov     _digit_div,10
                call    _digit
                call    _puts
digitw_err:
                popa
                ret
digitw          ENDP

;----------------------------------------------
;       digitz
;----------------------------------------------
digitz          PROC    near
                mov     COLOR_ATTRIB,0C1h
                pusha
                mov     _digit_zsup,'0'
                mov     _digit_div,10
                call    _digit
                call    _puts
digitz_err:
                popa
                ret
digitz          ENDP
;----------------------------------------------
;       digiti
;----------------------------------------------
digiti          PROC    near
                mov     COLOR_ATTRIB,081h
                pusha
                mov     cx,0FFFFh
                mov     _digit_zsup,'0'
                mov     _digit_div,10
                call    _digit
                call    _puts
digiti_err:
                popa
                ret
digiti          ENDP
